<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Load all orders - Danh sách đơn hàng</title>
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
  </head>

  <body onload="onPageLoading()">
    <div class="container-fluid pt-4">
      <h2 class="text-center pb-3">Danh sách đơn hàng</h2>
      <button class="btn btn-success" style="margin-bottom: 1rem;" onclick="onBtnThemDonHangClick()">Thêm đơn hàng</button>
      <table class="table text-center table-striped" id="table-order">
        <thead>
          <tr>
            <th scope="col">Order Code</th>
            <th scope="col">Kích cỡ combo</th>
            <th scope="col">Loại pizza</th>
            <th scope="col">Nước uống</th>
            <th scope="col">Thành tiền</th>
            <th scope="col">Họ và tên</th>
            <th scope="col">Số điện thoại</th>
            <th scope="col">Trạng thái</th>
            <th scope="col">Chi tiết</th>
            <th scope="col">Delete</th>
          </tr>
        </thead>
        <tbody></tbody>
      </table>
    </div>

    <script>
      "use strict";
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      const gREQUEST_STATUS_OK = 200;
      const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
      const gREQUEST_DELETE_SUCCESS = 204;

      const gEND_ROW_TABLE = -1;
      // Biến toàn cục định nghĩa chỉ số các cột tương ứng
      const gORDER_CODE_COL = 0;
      const gSIZE_COL = 1;
      const gLOAI_COL = 2;
      const gDRINK_COL = 3;
      const gTHANH_TIEN_COL = 4;
      const gHO_TEN_COL = 5;
      const gSDT_COL = 6;
      const gTRANG_THAI_COL = 7;
      const gCHI_TIET_COL = 8;
      const gDELETE_COL = 9;

      /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      // Hàm thực hiện khi load trang
      function onPageLoading() {
        getAllOrders();
      }

      // onBtnChiTietClick, ấn nút chi tiết
      function onBtnChiTietClick(paramDetailButton) {
        var vId = paramDetailButton.dataset.id;
        var vOrderCode = paramDetailButton.dataset.ordercode;

        console.log("id: " + vId);
        console.log("order code: " + vOrderCode);

        const vDETAIL_FORM_URL = "orderDetail.html";
        var vUrlSiteToOpen =
          vDETAIL_FORM_URL + "?" + "id=" + vId + "&orderCode=" + vOrderCode;
        window.location.href = vUrlSiteToOpen;
      }

      // hàm thực thi khi ấn nút Delete
      function onBtnDeleteClick(paramDeleteButton) {
        if (confirm("Bạn có chắc chắn muốn xóa đơn hàng này không?") == true) {
          var vIdObj = {
            id: "",
          };

          //B1: Thu thập dữ liệu
          thuThapDuLieuDelete(paramDeleteButton, vIdObj);
          //B2: Kiểm tra dữ liệu
          var vCheckD = kiemTraDuLieuDelete(vIdObj);
          if (vCheckD) {
            //B3: gọi api để xóa
            var vXmlHttpOrder = new XMLHttpRequest();
            goiApiDelete(vXmlHttpOrder, vIdObj);
            vXmlHttpOrder.onreadystatechange = function () {
              if (
                this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
                this.status == gREQUEST_DELETE_SUCCESS
              ) {
                console.log("Delete order " + vIdObj.id + " thành công!");
                alert("Delete order thành công!");
              }
            };
          }
        }
      }

      //hàm thực thi khi nút Thêm đơn hàng được ấn
      function onBtnThemDonHangClick() {
        const vCREATE_ORDER_URL = "create.order.html";
        window.location.href = vCREATE_ORDER_URL;
      }
      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      // Hàm thực hiện việc load all orders từ server và load vào table
      function getAllOrders() {
        /**
         * Chia để trị - 04 bước cố gắng thành 04 functions riêng biệt
         */
        // B1: Thu thập dữ liệu (trong bài này bước này ko cần)
        // B2: Validate dữ liệu (trong bài này bước này ko cần)
        // B3: Thực hiện việc gọi API từ server Server
        var vXmlHttpGetAllOrders = new XMLHttpRequest();
        callApiToGetAllOrders(vXmlHttpGetAllOrders);

        // B4: Xử lý trên front-end khi request xử lý xong và trả về response thành công
        vXmlHttpGetAllOrders.onreadystatechange = function () {
          if (
            this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
            this.status == gREQUEST_STATUS_OK
          ) {
            loadOrderToTable(vXmlHttpGetAllOrders);
          }
        };
      }

      // hàm gọi api để lấy all orders
      function callApiToGetAllOrders(paramXMLHttpGetAllOrders) {
        const vBaseUrl = "http://203.171.20.210:8080/devcamp-pizza365/orders";
        paramXMLHttpGetAllOrders.open("GET", vBaseUrl, true);
        paramXMLHttpGetAllOrders.send();
      }

      // input: xml http request đã đươc trả lời
      // ouptut/end: dữ liệu hiên thi trên bảng
      function loadOrderToTable(paramXMLHttpAllOrder) {
        //CODE Ở ĐÂY ĐỂ LOAD DATA VÀO TABLE
        var vOrderListString = paramXMLHttpAllOrder.responseText;
        var vOrderListObj = JSON.parse(vOrderListString);
        console.log(vOrderListObj);

        var vTable = document.getElementById("table-order");
        var vTableBody = vTable.getElementsByTagName("tbody")[0];

        for (var bIndex = 0; bIndex < vOrderListObj.length; bIndex++) {
          var vOrderObj = vOrderListObj[bIndex];

          // tạo dòng mới cho bảng và ghi vào các giá trị
          var vRow = vTableBody.insertRow(gEND_ROW_TABLE);

          var vCellOrderCode = vRow.insertCell(gORDER_CODE_COL);
          var vCellSize = vRow.insertCell(gSIZE_COL);
          var vCellLoai = vRow.insertCell(gLOAI_COL);
          var vCellDrink = vRow.insertCell(gDRINK_COL);
          var vCellThanhTien = vRow.insertCell(gTHANH_TIEN_COL);
          var vCellHoTen = vRow.insertCell(gHO_TEN_COL);
          var vCellSdt = vRow.insertCell(gSDT_COL);
          var vCellTrangThai = vRow.insertCell(gTRANG_THAI_COL);
          var vCellChiTiet = vRow.insertCell(gCHI_TIET_COL);
          var vCellDelete = vRow.insertCell(gDELETE_COL);

          vCellOrderCode.innerHTML = vOrderObj.orderCode;
          vCellSize.innerHTML = vOrderObj.kichCo;
          vCellLoai.innerHTML = vOrderObj.loaiPizza;
          vCellDrink.innerHTML = vOrderObj.idLoaiNuocUong;
          vCellThanhTien.innerHTML = vOrderObj.thanhTien;
          vCellHoTen.innerHTML = vOrderObj.hoTen;
          vCellSdt.innerHTML = vOrderObj.soDienThoai;
          vCellTrangThai.innerHTML = vOrderObj.trangThai;

          // thêm data vào các dòng của button
          var vDetailButton = document.createElement("button"); //tạo element button
          vCellChiTiet.appendChild(vDetailButton); // gắn nó vào ô
          vDetailButton.innerHTML = "Chi tiết"; //thêm label (nhãn của  button)
          vDetailButton.className = "btn btn-info info-user"; //kiểu button bootstrap và "info-user" là class để truy cập button sau này
          vDetailButton.setAttribute("data-id", vOrderObj.id);
          vDetailButton.setAttribute("data-ordercode", vOrderObj.orderCode);
          vDetailButton.setAttribute("onclick", "onBtnChiTietClick(this)");

          //nút Delete
          var vDeleteButton = document.createElement("button");
          vCellDelete.appendChild(vDeleteButton);
          vDeleteButton.innerHTML = "Delete";
          vDeleteButton.className = "btn btn-danger delete-button";
          vDeleteButton.setAttribute("data-id", vOrderObj.id);
          vDeleteButton.setAttribute("onclick", "onBtnDeleteClick(this)");
        }
      }

      //hàm thu thập dữ liệu id của nút Delete
      function thuThapDuLieuDelete(paramPDeleteButton, paramIdObj) {
        var vId = paramPDeleteButton.dataset.id;
        console.log(vId);
        paramIdObj.id = vId;
      }

      //hàm kiểm tra dữ liệu của nút Delete
      function kiemTraDuLieuDelete(paramIdObj) {
        if (typeof paramIdObj.id == "undefined") {
          alert("lỗi id");
          return false;
        }

        return true;
      }

      //hàm gọi api để xóa order
      function goiApiDelete(paramXmlHttpOrder, paramIdObj) {
        const vBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";

        paramXmlHttpOrder.open("DELETE", vBASE_URL + "/" + paramIdObj.id, true);
        paramXmlHttpOrder.send();
      }
    </script>
  </body>
</html>
